# -*- coding: utf-8 -*-
"""Segmentation d'images conduite autonome.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/100AjTuoPdB81xMRVK3nWzFFUoqRdAqLC

# Segmentation d'images par réseau de neurones

TP proposé par **Simon Kirchhofer**. Contact : simon.kirchhofer@ens-rennes.fr

<img src="https://drive.google.com/uc?id=1NcyMHqvLVIUD2sugrCzJBD_HA2NLWn6h" width="100">

Ce TP propose de visualiser le fonctionnement d'un réseau convolutif réalisant de la segmentation d'image. 
Le réseau est entrainé sur des images de circulation et doit reconnaitre les parties de l'image correspondant à une route, un trottoire, un piéton, un cycliste ...

##Installation des dépendances et chargement des librairies
"""

# Commented out IPython magic to ensure Python compatibility.
! pip install git+https://github.com/divamgupta/image-segmentation-keras

from IPython.display import Image
# %matplotlib inline
import matplotlib
import matplotlib.pyplot as plt
import numpy as np
from os import listdir
from os.path import isfile, join

"""## Téléchargement de la base de données d'apprentissage"""

! wget https://github.com/divamgupta/datasets/releases/download/seg/dataset1.zip && unzip dataset1.zip

"""## Téléchargement de la base de données de test et des paramètres du réseau

Via Colab 
1.   Le dossier data_regression est partagé. Il contient toutes les données : https://drive.google.com/drive/folders/1ejKsqHetZE_gSUEaEaXQjd5b5RW1t-gv?usp=sharing
2.   En suivant le lien précédent, clique droit sur le titre du dossier "data_regression" "ajouter un raccourci à drive" et laisser la selection par défault "mon drive" Pour poser le chemin du dossier à la racine du drive
3.   La section suivante donne à colab l'accès au drive associé. On y retrouve les dossiers partagés, dont "data_regression"

En local sur votre machine :
1.  télécharger le dossier avec la base de données : https://drive.google.com/drive/folders/1ejKsqHetZE_gSUEaEaXQjd5b5RW1t-gv?usp=sharing
2.  Dans la cellule suivante, modifier la variable "path" pour qu'elle pointe vers le dossier téléchargé 
"""

from google.colab import drive
drive.mount('/content/drive')

path = 'drive/MyDrive/'

"""##Création du réseau de neurones

On charge le modèle vgg_unet. Les hyperparamètres sont définis par le concepteur de cette architecture (Francois Chollet).
"""

from keras_segmentation.models.unet import vgg_unet

model = vgg_unet(n_classes=50 ,  input_height=320, input_width=640  ) # Ce modèle créé par Francois Chollet contient déjà tous les hyperparamètres dont nous avons besoin

model.summary() #visualisation du choix de la structure

"""## Apprentissage

Attention, l'apprentissage d'un tel modèle peut être très long...
Les poids sont sauvegardés dans le dossier "checkpoints_path"
"""

# IL EST CONSEILLÉ DE NE PAS ENTRAINER CE MODELE. L'apprentissage dure plusieurs jours.
# Dans la cellule suivante, nous pouvons charger les paramètres d'un réseau déjà entrainé.

model.train(
    train_images =  "dataset1/images_prepped_train/",
    train_annotations = "dataset1/annotations_prepped_train/",
    checkpoints_path = path + 'VGG_model' , epochs=10  # Cette ligne est responsable de l'enregistrement des paramètres (poids et biais) à chaque epoch sur le disque dur.
)

# Le paramètre "checkpoints_path" est responsable de l'enregistrement des paramètres (poids et biais) à chaque epoch dans le dossier 'path'.
# Il permet d'utiliser le réseau pour de l'inférence sans avoir à le ré-entrainer à chaque utilisation
# Il peut également permettre de reprendre l'apprentissage si il a été arrété trop tôt.

"""## Chargement des paramètres du réseau.

Le réseau a déjà été entrainé. Je n'ai plus qu'à charger les poids
"""

model.load_weights(path + 'VGG_model_2/VGG_model_2.00002') # Chargement des paramètres du réseau. Et voilà un réseau entrainé !

# NB : L'entrainement n'a duré que 6 epoch. Nous sommes dans un cas de sous-apprentissage et les performances sont réduites.

"""## Test du réseau de neurones entrainé.

Faisons de l'inférence sur quelques valeurs de la base de test pour vérifier que le réseau fonctionne bien.

Image 0016E5_07965.png
"""

img_input = "dataset1/images_prepped_test/0016E5_07965.png"
Image(img_input)

"""On réalise l'inférence de cette image"""

out = model.predict_segmentation(
    inp=img_input,
    out_fname="/tmp/out.png"
)
Image('/tmp/out.png')

"""Affichage avec la segmentation en superposition avec l'image"""

o = model.predict_segmentation(
    inp="dataset1/images_prepped_test/0016E5_07965.png",
    out_fname="/tmp/out.png" , overlay_img=True, show_legends=True,
    class_names = [ "Ciel",    "Batiment", "Poteau","Route","Trottoir","Arbre","Signalisation", "Cloture", "Voiture","Pieton", "Cycliste"]

)
Image('/tmp/out.png')

"""Regardons si cette segmentation fonctionne également sur des images d'une autre base de données 

nom de la base de données : Kitti - http://www.cvlibs.net/datasets/kitti/
"""

path_kitti = path + 'Kitti/testing/image_2/'
list_img = [f for f in listdir(path_kitti) if isfile(join(path_kitti, f))] # Je fais la liste des images dans le dossier Kitti
img = path_kitti + np.random.choice(list_img) # Je choisis une image

#Inférence :
o = model.predict_segmentation(
    inp=img,
    out_fname="/tmp/out.png" , overlay_img=True, show_legends=True,
    class_names = [ "Ciel",    "Batiment", "Poteau","Route","Trottoir","Arbre","Signalisation", "Cloture", "Voiture","Pieton", "Cycliste"]

)

# Affichage
Image('/tmp/out.png')

# Les performances sont très dépendantes de l'image choisie. 
# Rappel : Nous sommes en sous-apprentissage. Il faut continuer l'entrainement (très couteux) pour améliorer les performances.